# $Revision: 1.132 $, $Date: 2008-03-09 22:10:29 $
# NOTE
# - don't use %{_*dir} macros for paths defined by FHS

# avoid rpm 4.4.9 adding rm -rf buildroot, we need the dirs to check consistency
%define		__spec_clean_body	%{nil}
Summary:	Basic FHS 2.3 filesystem layout
Summary(de.UTF-8):	Grundlegende Dateisystemstruktur
Summary(fr.UTF-8):	Arborescence de base du système de fichiers
Summary(pl.UTF-8):	Podstawowy układ katalogów systemu Linux zgodny z FHS 2.3
Summary(tr.UTF-8):	Temel dosya sistemi yapısı
Name:		FHS
Version:	2.3
Release:	23
License:	GPL
Group:		Base
URL:		http://www.pathname.com/fhs/
BuildRequires:	mktemp
BuildRequires:	rpmbuild(macros) >= 1.213
Requires:	setup >= 2.4.6-4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_locmandir	/usr/local/man

# doesn't contain any files, but we're not noarch package
%define 	no_install_post_strip	1
%define 	no_install_post_chrpath	1
%define 	no_install_post_compress_modules	1

%description
This package contains the basic directory layout for a Linux system,
including the proper permissions for the directories. This layout
conforms to the Filesystem Hierarchy Standard (FHS) 2.3.

%description -l de.UTF-8
Dieses Paket enthält die grundlegende Verzeichnisstruktur eines
Linux-Systems, einschließlich der entsprechenden Zugriffsrechte. Diese
Struktur entspricht dem Filesystem Hierarchy Standard (FHS) 2.3.

%description -l fr.UTF-8
Ce package contient l'arborescence type pour système Linux y compris
les permissions adéquates pour les répertoires. Cette arborescence est
conforme au standard "Filesystem Hierarchy Standard" (FHS) 2.3.

%description -l pl.UTF-8
Pakiet ten zawiera informacje o podstawowej strukturze katalogów
systemu i praw dostępu do nich. Struktura katalogów jest zgodna z FHS
2.3.

%description -l tr.UTF-8
Bu paket GNU makro işleme dilini içerir. Mantıksal olarak
ayrıştırılabilen metin dosyaları yazımı için yararlıdır.

%prep

%install
rm -rf $RPM_BUILD_ROOT

install -d \
	$RPM_BUILD_ROOT/{bin,boot,dev,etc,home,opt,srv} \
	$RPM_BUILD_ROOT/etc/{X11,opt} \
	$RPM_BUILD_ROOT/lib/modules \
	$RPM_BUILD_ROOT/{mnt,media/{cdrom,floppy},proc,root,sbin,tmp} \
	$RPM_BUILD_ROOT/usr/{bin,games,include,lib,sbin,share,src} \
	$RPM_BUILD_ROOT/usr/share/{dict,doc,games,info,misc,tmac,xml} \
	$RPM_BUILD_ROOT/usr/lib/games \
	$RPM_BUILD_ROOT/usr/local/{bin,etc,games,include,lib,sbin,share/{doc,info},src} \
	$RPM_BUILD_ROOT/var/{cache,crash,db,games,lib/misc,local,lock,log,mail,opt,run,spool,tmp,yp}

%if "%{_lib}" == "lib64"
install -d $RPM_BUILD_ROOT{/lib64,/usr/lib64/games,/usr/local/lib64}
%endif

for manp in man{1,2,3,4,5,6,7,8} ; do
	install -d $RPM_BUILD_ROOT/usr/share/man/${manp}
	install -d $RPM_BUILD_ROOT%{_locmandir}/${manp}
	for mloc in bg ca cs da de el eo es fi fr gl hr hu id it ja ko lt nl \
			pl pt pt_BR ro ru sk sl sr sv tr uk zh_CN zh_TW ; do
		install -d $RPM_BUILD_ROOT/usr/share/man/${mloc}/${manp}
	done
done

# "/usr/local/share/man and /usr/local/man must be synonomous" per FHS 2.3
ln -sf ../man $RPM_BUILD_ROOT/usr/local/share/man

%clean
cd $RPM_BUILD_ROOT

check_filesystem_dirs() {
	RPMFILE=%{name}-%{version}-%{release}.%{_target_cpu}.rpm
	TMPFILE=$(mktemp)
	find | sed -e 's|^\.||g' -e 's|^$||g' | LC_ALL=C sort > $TMPFILE

	# find finds also '.', so use option -B for diff
	if rpm -qpl %{_rpmdir}/$RPMFILE | grep -v '^/$' | LC_ALL=C sort | diff -uB $TMPFILE - ; then
		rm -rf $RPM_BUILD_ROOT
	else
		echo -e "\nNot so good, some directories are not included in package\n"
		exit 1
	fi
	rm -f $TMPFILE
}
check_filesystem_dirs

%files
%defattr(644,root,root,755)
%dir /
%dir /bin
%dir /boot
%dir /dev
%dir /etc
%dir /etc/X11
%dir /etc/opt
%dir /home
%dir /lib
%dir /lib/modules
%attr(775,root,disk) %dir /media
%attr(775,root,disk) /media/floppy
%attr(775,root,disk) /media/cdrom
%dir /mnt
%dir /opt
%attr(555,root,proc) %verify(not group) /proc
%attr(700,root,root) /root
%dir /sbin
%attr(751,root,root) /srv
%attr(1777,root,root) /tmp
%dir /usr
%dir /usr/bin
%dir /usr/games
%dir /usr/include
%dir /usr/lib
%dir /usr/lib/games
%dir /usr/sbin
%dir /usr/share
%dir /usr/share/dict
%dir /usr/share/doc
%dir /usr/share/games
%dir /usr/share/info
%dir /usr/share/man
%dir /usr/share/man/man[1-8]
%lang(bg) /usr/share/man/bg
%lang(ca) /usr/share/man/ca
%lang(cs) /usr/share/man/cs
%lang(da) /usr/share/man/da
%lang(de) /usr/share/man/de
%lang(el) /usr/share/man/el
%lang(eo) /usr/share/man/eo
%lang(es) /usr/share/man/es
%lang(fi) /usr/share/man/fi
%lang(fr) /usr/share/man/fr
%lang(gl) /usr/share/man/gl
%lang(hr) /usr/share/man/hr
%lang(hu) /usr/share/man/hu
%lang(id) /usr/share/man/id
%lang(it) /usr/share/man/it
%lang(ja) /usr/share/man/ja
%lang(ko) /usr/share/man/ko
%lang(lt) /usr/share/man/lt
%lang(nl) /usr/share/man/nl
%lang(pl) /usr/share/man/pl
%lang(pt) /usr/share/man/pt
%lang(pt_BR) /usr/share/man/pt_BR
%lang(ro) /usr/share/man/ro
%lang(ru) /usr/share/man/ru
%lang(sl) /usr/share/man/sl
%lang(sk) /usr/share/man/sk
%lang(sr) /usr/share/man/sr
%lang(sv) /usr/share/man/sv
%lang(tr) /usr/share/man/tr
%lang(uk) /usr/share/man/uk
%lang(zh_CN) /usr/share/man/zh_CN
%lang(zh_TW) /usr/share/man/zh_TW
%dir /usr/share/misc
%dir /usr/share/tmac
%dir /usr/share/xml
%dir /usr/src
%dir /usr/local
%dir /usr/local/bin
%dir /usr/local/etc
%dir /usr/local/games
%dir /usr/local/include
%dir /usr/local/lib
%dir /usr/local/sbin
%dir /usr/local/share
%dir /usr/local/share/doc
%dir /usr/local/share/info
/usr/local/share/man
%{_locmandir}
%dir /usr/local/src
%dir /var
%dir /var/cache
%dir /var/crash
%dir /var/db
%dir /var/games
%dir /var/lib
%dir /var/lib/misc
%dir /var/local
%attr(1771,root,uucp) %dir /var/lock
%attr(751,root,root) /var/log
%attr(2775,root,mail) /var/mail
%dir /var/opt
%dir /var/run
%dir /var/spool
%dir /var/yp
%attr(1777,root,root) %dir /var/tmp
%if "%{_lib}" == "lib64"
%dir /lib64
%dir /usr/lib64
%dir /usr/lib64/games
%dir /usr/local/lib64
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: FHS.spec,v $
Revision 1.132  2008-03-09 22:10:29  qboosh
- added dirs for lt manuals
- release 23

Revision 1.131  2008-02-09 10:33:27  glen
- %{_rpmfilename} consist of tags, not macros, it will never work

Revision 1.130  2008-02-08 21:18:47  glen
- rpm 4.4.9+ compatible %clean

Revision 1.129  2008-01-24 22:39:02  glen
- reason why no_install_post_{strip,chrpat,compress_modules} are used, however these could as well not be here

Revision 1.128  2008-01-01 00:23:18  adamg
- first new year's commit
- happy new year!

Revision 1.127  2007-12-26 18:51:52  glen
- rel 22

Revision 1.126  2007-09-06 13:50:24  baggins
- rel 21

Revision 1.125  2007/08/26 11:50:05  adamg
- release 20

Revision 1.124  2007/06/17 11:42:28  qboosh
- /var/yp belongs to FHS now

Revision 1.123  2007/06/09 14:53:24  blues
- rel.19 - eo added

Revision 1.122  2007/06/08 21:55:27  areq
- add /var/yp
  [release 18]

Revision 1.121  2007/05/30 18:41:13  areq
- no_install_post_strip

Revision 1.120  2007/02/12 21:21:30  glen
- tabs in preamle

Revision 1.119  2007/02/12 00:48:33  baggins
- converted to UTF-8

Revision 1.118  2006/11/24 13:28:47  glen
- /usr/share was listed twice in %files

Revision 1.117  2006/11/23 21:17:34  qboosh
- added dir for ca manuals (used in po4a), release 17

Revision 1.116  2006/11/19 21:33:15  qboosh
- added common /usr/share/xml (as specified by FHS 2.3)
- release 16

Revision 1.115  2006/10/27 18:13:35  qboosh
- removed all dirs not covered by FHS 2.3 (moved to filesystem.spec)
- release 15

Revision 1.114  2006/05/25 15:25:08  wolf
- filesystem with common directories

Revision 1.113  2006/05/12 18:25:27  pluto
- back to release 14.1. wjat about other dirs?
  /usr/share/{sounds,themes,java,xsessions,wm-properties,wallpapers}
  /etc/xdg and locales stuff.

Revision 1.112  2006/05/10 20:26:06  adgor
- Added %{_datadir}/{icons,pixmaps}
- Rel. 15; STBS for TH

Revision 1.111  2006/02/05 11:15:06  pluto
- X11R6 doesn't exist in th.

Revision 1.110  2006/02/05 11:03:05  pluto
- more font dirs for modular xorg.

Revision 1.109  2006/01/01 00:10:56  adamg
- first new year's commit

Revision 1.108  2006/01/01 00:07:20  adamg
- first new year's commit, happy new year to everyone

Revision 1.107  2005/12/12 16:24:19  glen
- adapterized (sorted %verify attrs)

Revision 1.106  2005/12/10 13:28:17  qboosh
- sync localized man dirs with man

Revision 1.105  2005/11/05 14:33:18  qboosh
- added dir for tr manuals; release 13

Revision 1.104  2005/08/27 21:43:22  twittner
- fixed typos in my commitlogs

Revision 1.103  2005/06/30 20:15:26  twittner
- changed location for cgi programs:
  %{_libdir}/cgi-bin -> %{_prefix}/lib/cgi-bin .
  There's no need to have two different directories on
  different archs (/usr/lib vs. /usr/lib64 issue) - one
  /usr/lib/cgi-bin is sufficient and good for all archs.
- rel. 12

Revision 1.102  2005/05/11 13:22:05  qboosh
- use x8664 macro

Revision 1.101  2005/04/22 09:51:33  mmazur
- rel 11 (a couple of changes)

Revision 1.100  2005/01/16 15:00:51  zawadaa
- fix: no %{_lib}/firmware just /lib/firmware

Revision 1.99  2005/01/15 22:03:39  zawadaa
- added %{_lib}/firmware directory for packages with firmware
  and use by hotplug

Revision 1.98  2005/01/01 00:06:20  adamg
- first

Revision 1.97  2004/12/31 23:20:08  adamg
- pierwszy

Revision 1.96  2004/12/19 22:27:37  ankry
- added uk man tree

Revision 1.95  2004/12/08 20:49:37  mmazur
- rel 10 for Th

Revision 1.94  2004/10/12 20:30:50  mmazur
- rel 9 for th

Revision 1.93  2004/09/17 11:55:42  gotar
- added /etc/certs

Revision 1.92  2004/09/06 10:45:27  qboosh
- FHS 2.3 fixes:
  - added missing /usr/local/etc dir (consider changing it into symlink to /etc/local?)
  - added /usr/local/share/man as symlink to /usr/local/man (they must be synonymous)

Revision 1.91  2004/09/02 19:32:04  twittner
- added %{_libdir}/cgi-bin directory for cgi apps. This helps to make
  cgi applications "apache independent".
- rel. 8

Revision 1.90  2004/09/01 01:07:35  ankry
- %files fix

Revision 1.89  2004/09/01 01:07:04  havner
- %files fixed, rel 7

Revision 1.88  2004/09/01 00:53:20  ankry
- added missing and removed unused man dirs, rel. 6

Revision 1.87  2004/07/29 19:59:18  qboosh
- /lib/security -> /%{_lib}/security fix; release 5

Revision 1.86  2004/06/29 20:52:24  djurban
- revert my bogus changes, group of services set to adm, rel. 4

Revision 1.85  2004/06/29 13:26:59  djurban
- require setup 2.4.7

Revision 1.84  2004/06/29 13:03:33  djurban
- add services group for /home/services, this was driving me crazy

Revision 1.83  2004/05/18 21:25:11  saq
- fix fr description

Revision 1.82  2004/05/18 10:13:54  arekm
- rel 2; add /initrd

Revision 1.81  2004/03/05 15:26:33  deejay1
- rel. 1

Revision 1.80  2004/02/19 13:37:59  deejay1
- readded /home/services; chlog cosmetics

Revision 1.79  2004/02/04 17:36:12  adgor
- Cannot find setup >= 3.4.5-4 ;P

Revision 1.78  2004/02/04 16:08:12  qboosh
- require setup with fstab containing /media entries

Revision 1.77  2004/02/04 14:20:45  averne
- FHS 2.3 compilant

Revision 1.76  2004/01/26 01:03:20  ankry
- reversed

Revision 1.75  2004/01/23 22:49:28  ankry
- added man9: libgii uses it; rel. 17

Revision 1.74  2003/12/11 00:18:04  arekm
- added /selinux

Revision 1.73  2003/11/29 13:41:15  qboosh
- lib64 only on supporting archs (so nolonger noarch...); release 15

Revision 1.72  2003/11/16 14:08:59  arekm
- added lib64; rel 14

Revision 1.71  2003/09/23 07:57:29  arekm
- 2755,root,mail on /var/mail; rel 13

Revision 1.70  2003/09/17 11:11:23  trojan
- removed BR: grep, textutils (required by rpm-build)

Revision 1.69  2003/09/03 18:10:04  blues
- release 12 (sync with RA)

Revision 1.68  2003/08/14 11:03:24  adgor
- Added %{_datadir}/applications
- Release 11

Revision 1.67  2003/08/12 15:08:19  qboosh
- cleanups, mainly in preambles

Revision 1.66  2003/08/10 11:48:43  qboosh
- added dir for el manuals, release 10

Revision 1.65  2003/07/26 16:41:48  qboosh
- added /usr/include/security dir (used by opie-devel,pam-devel,skey-devel)
- release 9

Revision 1.64  2003/06/25 08:51:39  wrobell
- added /usr/share/fonts/misc directory

Revision 1.63  2003/06/21 14:45:12  wrobell
- added /usr/share/fonts/TTF directory
- rel. 8

Revision 1.62  2003/05/25 05:45:21  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.61  2003/03/11 22:25:13  qboosh
- added dir for ro manuals; release 7

Revision 1.60  2003/03/08 23:05:14  blues
- release 6 - added /sys dir - for new sysfs in kernel 2.5

Revision 1.59  2003/02/27 14:42:33  qboosh
- changed idl dir to /usr/share/idl; release 5 (NOT for Ra!)

Revision 1.58  2003/01/22 21:15:40  qboosh
- added missing dirs, required by FHS 2.2: /usr/local/include, /var/local
- added %{_mandir}/pl/mann dir (we have some pl man pages for tcl)
- release 4

Revision 1.57  2003/01/19 18:44:25  qboosh
- added dir for gl manuals; release 3

Revision 1.56  2003/01/07 16:19:11  wrobell
- rel. 2

Revision 1.55  2003/01/07 08:03:21  trojan
- s/2.1/2.2/

Revision 1.54  2002/12/20 22:35:12  qboosh
- eeeh, let it be - it's 2.2 conforming at the same level as was with 2.1

Revision 1.53  2002/12/19 23:57:20  qboosh
- ugh, /var/lock/subsys was writable for uucp group - fixed
- release 26, STBR (even for updates/security)

Revision 1.52  2002/07/15 20:24:25  qboosh
- added %{_xmandir}/sk dir
- removed %ghost from dirs - it caused problems: rpm -V complained about
  missing dirs and permissions weren't set correctly during upgrade
- release 25

Revision 1.51  2002/06/25 07:58:10  qboosh
- added /usr/share/empty as commot privilege separation dir; release 24

Revision 1.50  2002/06/10 14:51:16  ankry
- international mandirs made %ghost; they are now created while the
  appropriate manpages are installed
- release 23

Revision 1.49  2002/05/17 11:22:43  ankry
- Oops, restoret /var/log attributes
- 1771,root/uucp on /var/lock

Revision 1.48  2002/05/17 10:48:42  ankry
- changed /var/log owner/permissions (4771 root/uucp)
- added more _xmandir subdirs for national man pages
- release 22

Revision 1.47  2002/04/04 00:26:11  kloczek
- release 21.

Revision 1.46  2002/03/30 22:43:14  qboosh
- fixed mann dir
- added manl dir (used by e.g. postgresql for SQL commands manuals)

Revision 1.45  2002/03/30 18:39:19  mmazur
- fixed; builds ok... STBR???????????????

Revision 1.44  2002/03/30 18:16:09  mmazur
- let's call it a typo

Revision 1.43  2002/03/09 20:57:46  qboosh
- release 20: added dirs for X11R6 it,ko,pl manuals

Revision 1.42  2002/03/08 21:28:47  qboosh
- release 19: added directory for X11R6 ja manuals

Revision 1.41  2002/03/06 00:02:30  qboosh
- towards FHS 2.2: locmandir changed to /usr/local/man (still 2.1-compliant)
- release 18

Revision 1.40  2002/03/04 12:38:12  kloczek
- release 17.

Revision 1.39  2002/03/04 10:38:11  gotar
- removed %{_applnkdir} - it belongs to applnk.

Revision 1.38  2002/02/22 23:28:37  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.37  2002/02/20 11:32:27  qboosh
- added /home/services directory, release 16

Revision 1.36  2002/01/18 02:12:10  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.35  2002/01/03 23:01:22  gotar
- added BuildRequires: {grep,textutils} (%clean section).

Revision 1.34  2001/12/13 02:38:27  gotar
- fixed Linux name spelling.

Revision 1.33  2001/11/26 10:24:03  kloczek
- reverte last changes (%{_libdir}/pkgconfig is in pkgconfig package).

Revision 1.32  2001/11/25 16:13:07  gotar
- added %{_libdir}/pkgconfig dir to the package contents,
- release 16.

Revision 1.31  2001/11/02 01:28:00  qboosh
- added directories for id manuals
- added /usr/src/examples directory
- release 15

Revision 1.30  2001/10/18 16:40:22  gotar
- cosmetics.

Revision 1.29  2001/10/15 21:50:32  qboosh
- relese 14: added dir for hr manpages

Revision 1.28  2001/09/16 16:55:38  qboosh
- oops... added %{_mandir}/{hu,ko} to %files too

Revision 1.27  2001/09/16 13:56:30  qboosh
- release 13: added %{_mandir}/{hu,ko}/man[1-8] dirs

Revision 1.26  2001/08/30 12:18:48  gotar
- awful %configure macro expansions removed,
- other specs' changelogs cosmetical fixes,
- no functional nor release changes.

Revision 1.25  2001/08/03 16:44:33  qboosh
- added %verify(not group) to /proc (can be root or proc depending on kernel)
- added Group(de)
- release 12

Revision 1.24  2001/07/17 06:34:55  gotar
- reverted /proc group to 'proc,
- cya.

Revision 1.23  2001/07/16 17:25:12  gotar
- changed /proc group from 'proc' to 'root';
  that's the way 2.4.x kernels handle it.

Revision 1.22  2001/07/15 10:43:22  kloczek
- release 11.

Revision 1.21  2001/07/15 10:21:34  qboosh
- added URL

Revision 1.20  2001/07/10 16:07:30  qboosh
- added /usr/lib/games (acc. to FHS 2.1 p. 4.7 - optional)
- release 10

Revision 1.19  2001/07/05 17:30:47  gotar
- removed /etc/profile.d from package contents, it's in setup,
- release 9.

Revision 1.18  2001/07/03 16:18:05  qboosh
- removed %{_fontsdir}/latin2 directory (to reflect last XFree86-fonts changes)
- release 8

Revision 1.17  2001/04/26 23:32:41  qboosh
- added /usr/share/fonts/Type1/{afm,pfm} dirs (one of them maybe temporarily)
- missing dirs: / and /dev
- release 7

Revision 1.16  2001/04/12 00:56:29  qboosh
- added /usr/X11R6/share/idl and /usr/share/fonts{,/Type1,/latin2} dirs
- release 6

Revision 1.15  2001/04/09 18:12:07  klakier
- Release 5
  /boot permisions changed from 700 to 755

Revision 1.14  2001/03/14 13:00:04  marcus
- fixed /proc group to "proc"
- release 4

Revision 1.13  2001/03/07 16:21:20  kloczek
- release 3.

Revision 1.12  2001/03/07 00:53:51  qboosh
- added man subdirs (localized too)

Revision 1.11  2000/07/21 17:22:28  mis
- added missing directories
- add created package content validation in %clean

Revision 1.10  2000/05/17 00:36:12  kloczek
- spec adapterized.

Revision 1.9  2000/04/25 16:16:47  baggins
- release++
- FHS 2.1, /var/state -> /var/lib

Revision 1.8  2000/04/19 18:30:46  kloczek
- version 1.1,
- removed /var/account - this directory must belong to processaccounting
  tools package (psacct).

Revision 1.7  2000/04/01 20:19:35  kloczek
- release 1,
- PAM related fix: 751 on /etc/security.

Revision 1.6  2000/04/01 11:14:21  zagrodzki
- changed all BuildRoot definitions
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicated empty lines

Revision 1.5  2000/03/28 16:54:13  baggins
- translated kloczkish into english

Revision 1.4  2000/03/23 16:35:19  jasio
- Poprawka błędu ortograficznego.

Revision 1.3  2000/03/09 00:40:37  wiget
- name is FHS not filesystem

Revision 1.2  2000/03/09 00:29:57  wiget
- no scripts!

Revision 1.1  2000/03/03 19:19:24  kloczek
- initial version package with base filesystem hierarchy structure compliant
  with FHS 2.0 (this package obsoletets filesystem).
